#ifndef _comm_h_
#define _comm_h_


#include "usb_config.h"
extern unsigned char CDCBufferOut[CDC_DATA_OUT_EP_SIZE];
extern unsigned char green_led_counter;

void ProcessCDC(void);

/** C O M M U N I C A T I O N ***************************************/
// address
#define CMD_HD_SYNC	0x00
#define CMD_HD_COMMAND	0x01
#define CMD_HD_CHECK	0x02
#define CMD_HD_LEN	0x03
#define CMD_DATA_START	0x04

// sync words
#define CMD_SYNC_SEND	0xAA
#define CMD_SYNC_RECV	0x55

// commands
#define CMD_SYS_SYNC            0x00
#define CMD_SYS_ACK             0x01
#define CMD_SYS_NACK            0x02
#define CMD_SYS_NIMP            0xFF
#define CMD_SYS_IR		0x10
#define CMD_SYS_DATA		0x20
#define CMD_SYS_NACK_LENGTH	0x03
#define CMD_SYS_NACK_CHECK	0x04

#define CMD_GET_VERSION		0x01
#define CMD_GET_HARDWARE        0x02

#define CMD_SET_DATA_00         0x20
#define CMD_SET_DATA_01         0x21
#define CMD_SET_DATA_02         0x22
#define CMD_SET_DATA_03         0x23
#define CMD_SET_DATA_04         0x24
#define CMD_SET_DATA_05         0x25
#define CMD_SET_DATA_06         0x26
#define CMD_SET_DATA_07         0x27
#define CMD_SET_DATA_08         0x28
#define CMD_SET_DATA_09         0x29
#define CMD_SET_DATA_10         0x2A
#define CMD_SET_DATA_11         0x2B
#define CMD_SET_DATA_12         0x2C
#define CMD_SET_DATA_13         0x2D
#define CMD_SET_DATA_14         0x2E
#define CMD_SET_DATA_15         0x2F


#define CMD_GET_N_CHANNELS      0x30

#define CMD_BOOT_REQUEST	0x80
#define CMD_BOOT_START		0x81




#define HW_ID_KARATE            0x01
#define HW_ID_USB2DMX           0x02



#endif
