#ifndef _irdecoders_h_
#define _irdecoders_h_


#define IR_TIMER_INTERVAL  		0.33333
#define IR_TOLERANCE			1.5


#define IR_SHARP_PULSE_MS			320
#define IR_SHARP_PAUSE_LONG_MS		(2000 - IR_SHARP_PULSE_MS)
#define IR_SHARP_PAUSE_SHORT_MS		(1000 - IR_SHARP_PULSE_MS)
#define IR_SHARP_PULSE_SHORT_MIN	(int)((IR_SHARP_PULSE_MS / IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_SHARP_PULSE_SHORT_MAX	(int)((IR_SHARP_PULSE_MS * IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_SHARP_PAUSE_SHORT_MIN	(int)((IR_SHARP_PAUSE_SHORT_MS / IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_SHARP_PAUSE_SHORT_MAX	(int)((IR_SHARP_PAUSE_SHORT_MS * IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_SHARP_PAUSE_LONG_MIN		(int)((IR_SHARP_PAUSE_LONG_MS / IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_SHARP_PAUSE_LONG_MAX		(int)((IR_SHARP_PAUSE_LONG_MS * IR_TOLERANCE) / IR_TIMER_INTERVAL)


#define IR_RC5_PULSE_SHORT_MS	889
#define IR_RC5_PULSE_LONG_MS	(2 * IR_RC5_PULSE_SHORT_MS)
#define IR_RC5_PULSE_SHORT_MIN	(int)((IR_RC5_PULSE_SHORT_MS / IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_RC5_PULSE_SHORT_MAX	(int)((IR_RC5_PULSE_SHORT_MS * IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_RC5_PULSE_LONG_MIN	(int)((IR_RC5_PULSE_LONG_MS / IR_TOLERANCE)  / IR_TIMER_INTERVAL)
#define IR_RC5_PULSE_LONG_MAX	(int)((IR_RC5_PULSE_LONG_MS * IR_TOLERANCE)  / IR_TIMER_INTERVAL)


#define IR_NEC_PULSE_MS			560
#define IR_NEC_AGC0_MS			(16 * IR_NEC_PULSE_MS)
#define IR_NEC_AGC1_MS			(8 * IR_NEC_PULSE_MS)
#define IR_NEC_REPEAT_MS		(4 * IR_NEC_PULSE_MS)
#define IR_NEC_AGC0_MIN			(int)((IR_NEC_AGC0_MS / IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_NEC_AGC0_MAX			(int)((IR_NEC_AGC0_MS * IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_NEC_AGC1_MIN			(int)((IR_NEC_AGC1_MS / IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_NEC_AGC1_MAX			(int)((IR_NEC_AGC1_MS * IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_NEC_PULSE_MIN		(int)((IR_NEC_PULSE_MS / IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_NEC_PULSE_MAX		(int)((IR_NEC_PULSE_MS * IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_NEC_PULSE_3X_MIN		(int)((IR_NEC_PULSE_MS / IR_TOLERANCE) / IR_TIMER_INTERVAL * 3)
#define IR_NEC_PULSE_3X_MAX		(int)((IR_NEC_PULSE_MS * IR_TOLERANCE) / IR_TIMER_INTERVAL * 3)
#define IR_NEC_REPEAT_MIN		(int)((IR_NEC_REPEAT_MS / IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_NEC_REPEAT_MAX		(int)((IR_NEC_REPEAT_MS * IR_TOLERANCE) / IR_TIMER_INTERVAL)

#define IR_RC6_PULSE_TIME_MS	444
#define IR_RC6_LEADER_PULSE		(6 * IR_RC6_PULSE_TIME_MS)
#define IR_RC6_LEADER_SPACE		(2 * IR_RC6_PULSE_TIME_MS)
#define IR_RC6_PULSE			(1 * IR_RC6_PULSE_TIME_MS)
#define IR_RC6_PULSE_2X			(2 * IR_RC6_PULSE_TIME_MS)
#define IR_RC6_PULSE_3X			(3 * IR_RC6_PULSE_TIME_MS)
#define IR_RC6_LEADER_PULSE_MIN	(int)((IR_RC6_LEADER_PULSE / IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_RC6_LEADER_PULSE_MAX	(int)((IR_RC6_LEADER_PULSE * IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_RC6_LEADER_SPACE_MIN	(int)((IR_RC6_LEADER_SPACE / IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_RC6_LEADER_SPACE_MAX	(int)((IR_RC6_LEADER_SPACE * IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_RC6_PULSE_MIN		(int)((IR_RC6_PULSE / IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_RC6_PULSE_MAX		(int)((IR_RC6_PULSE * IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_RC6_PULSE_2X_MIN		(int)((IR_RC6_PULSE_2X / IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_RC6_PULSE_2X_MAX		(int)((IR_RC6_PULSE_2X * IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_RC6_PULSE_3X_MIN		(int)((IR_RC6_PULSE_3X / IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_RC6_PULSE_3X_MAX		(int)((IR_RC6_PULSE_3X * IR_TOLERANCE) / IR_TIMER_INTERVAL)
#define IR_RC6_BIT_TOGGLE_POS	5



/*
 RC5-Kommandos
*/
#define IR_RC5_KEY_0			0
#define IR_RC5_KEY_1			1
#define IR_RC5_KEY_2			2
#define IR_RC5_KEY_3			3
#define IR_RC5_KEY_4			4
#define IR_RC5_KEY_5			5
#define IR_RC5_KEY_6			6
#define IR_RC5_KEY_7			7
#define IR_RC5_KEY_8			8
#define IR_RC5_KEY_9			9
#define IR_RC5_KEY_POWER		12
#define IR_RC5_KEY_MUTE			13
#define IR_RC5_KEY_VOL_PLUS		16
#define IR_RC5_KEY_VOL_MINUS	17
#define IR_RC5_KEY_CHAN_UP		32
#define IR_RC5_KEY_CHAN_DOWN	33
#define IR_RC5_KEY_CURSOR_UP	80
#define IR_RC5_KEY_CURSOR_DOWN	81
#define IR_RC5_KEY_CURSOR_LEFT	85
#define IR_RC5_KEY_CURSOR_RIGHT	86
#define IR_RC5_KEY_OKAY			87
#define IR_RC5_KEY_MENUE		82
#define IR_RC5_KEY_RED			107
#define IR_RC5_KEY_GREEN		108
#define IR_RC5_KEY_YELLOW		109
#define IR_RC5_KEY_BLUE			110



/*
  Konstanten fr die einzelnen Infrarot Protokolle YARD compatibel!
*/
#define IRP_RC5			0x01
#define IRP_NEC			0x05
#define IRP_SHARP		0x0C
//#define IRP_SIRC12        0x02
//#define IRP_SIRC15        0x03
//#define IRP_SIRC20        0x04
//#define IRP_JAPAN         0x06
#define IRP_RC6           0x08
//#define IRP_NEC_REPEAT    0x09
//#define IRP_RECS80        0x0A 
//#define IRP_RCA           0x0B
#define IRP_RC6A          0x18


#define IR_FLAG_DATA_OK		0x01

typedef enum TYPE_IR_STATE {
    IR_RESET_STATE = 0x00,
    IR_RECV_OK,
    IR_END_OF_FIRST_HIGH,


	IR_RC5_DECODE = 0x10,	
	
	IR_NEC_CHECK_AGC1 = 0x20,
	IR_NEC_CHECK_PAUSE,
	IR_NEC_CHECK_PULSE,
	IR_NEC_CHECK_REPEAT,
	IR_NEC_REPEAT_OK,
	
	IR_SHARP_CHECK_PAUSE = 0x30,
	IR_SHARP_CHECK_PULSE,
	
	IR_RC6_CHECK_LEADER_SPACE = 0x40,
	IR_RC6_DECODE,

     
    IR_FINAL_STATE = 0xFF
 };


extern enum TYPE_IR_STATE	ir_state;
extern unsigned char 		ir_proto;
extern unsigned int			ir_command;
extern unsigned int			ir_address;
extern unsigned char		ir_repeat;
extern unsigned char		ir_flags;

void IR_Decode(void);


#endif
